    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------------
    028     * StandardCategoryItemLabelGenerator.java
    029     * ---------------------------------------
    030     * (C) Copyright 2004-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 11-May-2004 : Version 1 (DG);
    038     * 20-Apr-2005 : Renamed StandardCategoryLabelGenerator
    039     *               --> StandardCategoryItemLabelGenerator (DG);
    040     * ------------- JFREECHART 1.0.0 ---------------------------------------------
    041     * 03-May-2005 : Added equals() implementation, to fix bug 1481087 (DG);
    042     */
    043
    044    package org.jfree.chart.labels;
    045
    046    import java.io.Serializable;
    047    import java.text.DateFormat;
    048    import java.text.NumberFormat;
    049
    050    import org.jfree.data.category.CategoryDataset;
    051    import org.jfree.util.PublicCloneable;
    052
    053    /**
    054     * A standard label generator that can be used with a
    055     * {@link org.jfree.chart.renderer.category.CategoryItemRenderer}.
    056     */
    057    public class StandardCategoryItemLabelGenerator
    058        extends AbstractCategoryItemLabelGenerator
    059        implements CategoryItemLabelGenerator, Cloneable, PublicCloneable,
    060                   Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = 3499701401211412882L;
    064
    065        /** The default format string. */
    066        public static final String DEFAULT_LABEL_FORMAT_STRING = "{2}";
    067
    068        /**
    069         * Creates a new generator with a default number formatter.
    070         */
    071        public StandardCategoryItemLabelGenerator() {
    072            super(DEFAULT_LABEL_FORMAT_STRING, NumberFormat.getInstance());
    073        }
    074
    075        /**
    076         * Creates a new generator with the specified number formatter.
    077         *
    078         * @param labelFormat  the label format string (<code>null</code> not
    079         *                     permitted).
    080         * @param formatter  the number formatter (<code>null</code> not permitted).
    081         */
    082        public StandardCategoryItemLabelGenerator(String labelFormat,
    083                                                  NumberFormat formatter) {
    084            super(labelFormat, formatter);
    085        }
    086
    087        /**
    088         * Creates a new generator with the specified number formatter.
    089         *
    090         * @param labelFormat  the label format string (<code>null</code> not
    091         *                     permitted).
    092         * @param formatter  the number formatter (<code>null</code> not permitted).
    093         * @param percentFormatter  the percent formatter (<code>null</code> not
    094         *     permitted).
    095         *
    096         * @since 1.0.2
    097         */
    098        public StandardCategoryItemLabelGenerator(String labelFormat,
    099                NumberFormat formatter, NumberFormat percentFormatter) {
    100            super(labelFormat, formatter, percentFormatter);
    101        }
    102
    103        /**
    104         * Creates a new generator with the specified date formatter.
    105         *
    106         * @param labelFormat  the label format string (<code>null</code> not
    107         *                     permitted).
    108         * @param formatter  the date formatter (<code>null</code> not permitted).
    109         */
    110        public StandardCategoryItemLabelGenerator(String labelFormat,
    111                                                  DateFormat formatter) {
    112            super(labelFormat, formatter);
    113        }
    114
    115        /**
    116         * Generates the label for an item in a dataset.  Note: in the current
    117         * dataset implementation, each row is a series, and each column contains
    118         * values for a particular category.
    119         *
    120         * @param dataset  the dataset (<code>null</code> not permitted).
    121         * @param row  the row index (zero-based).
    122         * @param column  the column index (zero-based).
    123         *
    124         * @return The label (possibly <code>null</code>).
    125         */
    126        public String generateLabel(CategoryDataset dataset, int row, int column) {
    127            return generateLabelString(dataset, row, column);
    128        }
    129
    130        /**
    131         * Tests this generator for equality with an arbitrary object.
    132         *
    133         * @param obj  the object (<code>null</code> permitted).
    134         *
    135         * @return <code>true</code> if this generator is equal to
    136         *     <code>obj</code>, and <code>false</code> otherwise.
    137         */
    138        public boolean equals(Object obj) {
    139            if (obj == this) {
    140                return true;
    141            }
    142            if (!(obj instanceof StandardCategoryItemLabelGenerator)) {
    143                return false;
    144            }
    145            return super.equals(obj);
    146        }
    147    }